namespace com.progsbase.no.inductive.libraries.SIMDArithmetic_v0_1_0{

using static System.Math;

public class F64bx4{
	public double n0;
	public double n1;
	public double n2;
	public double n3;
}
public class BooleanArrayReference{
	public bool [] booleanArray;
}
public class BooleanReference{
	public bool booleanValue;
}
public class CharacterReference{
	public char characterValue;
}
public class NumberArrayReference{
	public double [] numberArray;
}
public class NumberReference{
	public double numberValue;
}
public class StringArrayReference{
	public StringReference [] stringArray;
}
public class StringReference{
	public char [] stringx;
}
public class SIMDArithmetic{
	public static F64bx4 CreateF64bx4(double n0, double n1, double n2, double n3){
		F64bx4 f;

		f = new F64bx4();
		f.n0 = n0;
		f.n1 = n1;
		f.n2 = n2;
		f.n3 = n3;

		return f;
	}


	public static F64bx4 CreateF64bx4Broadcast(double n){
		F64bx4 f;

		f = new F64bx4();
		f.n0 = n;
		f.n1 = n;
		f.n2 = n;
		f.n3 = n;

		return f;
	}


	public static void AddF64bx4(F64bx4 x, F64bx4 a, F64bx4 b){
		x.n0 = a.n0 + b.n0;
		x.n1 = a.n1 + b.n1;
		x.n2 = a.n2 + b.n2;
		x.n3 = a.n3 + b.n3;
	}


	public static void SubtractF64bx4(F64bx4 x, F64bx4 a, F64bx4 b){
		x.n0 = a.n0 - b.n0;
		x.n1 = a.n1 - b.n1;
		x.n2 = a.n2 - b.n2;
		x.n3 = a.n3 - b.n3;
	}


	public static void MultiplyF64bx4(F64bx4 x, F64bx4 a, F64bx4 b){
		x.n0 = a.n0*b.n0;
		x.n1 = a.n1*b.n1;
		x.n2 = a.n2*b.n2;
		x.n3 = a.n3*b.n3;
	}


	public static void DivideF64bx4(F64bx4 x, F64bx4 a, F64bx4 b){
		x.n0 = a.n0/b.n0;
		x.n1 = a.n1/b.n1;
		x.n2 = a.n2/b.n2;
		x.n3 = a.n3/b.n3;
	}


	public static void SqrtF64bx4(F64bx4 x, F64bx4 a){
		x.n0 = Sqrt(a.n0);
		x.n1 = Sqrt(a.n1);
		x.n2 = Sqrt(a.n2);
		x.n3 = Sqrt(a.n3);
	}


	public static BooleanReference CreateBooleanReference(bool value){
		BooleanReference refx;

		refx = new BooleanReference();
		refx.booleanValue = value;

		return refx;
	}


	public static BooleanArrayReference CreateBooleanArrayReference(bool [] value){
		BooleanArrayReference refx;

		refx = new BooleanArrayReference();
		refx.booleanArray = value;

		return refx;
	}


	public static BooleanArrayReference CreateBooleanArrayReferenceLengthValue(double length, bool value){
		BooleanArrayReference refx;
		double i;

		refx = new BooleanArrayReference();
		refx.booleanArray = new bool [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.booleanArray[(int)(i)] = value;
		}

		return refx;
	}


	public static void FreeBooleanArrayReference(BooleanArrayReference booleanArrayReference){
		delete(booleanArrayReference.booleanArray);
		delete(booleanArrayReference);
	}


	public static CharacterReference CreateCharacterReference(char value){
		CharacterReference refx;

		refx = new CharacterReference();
		refx.characterValue = value;

		return refx;
	}


	public static NumberReference CreateNumberReference(double value){
		NumberReference refx;

		refx = new NumberReference();
		refx.numberValue = value;

		return refx;
	}


	public static NumberArrayReference CreateNumberArrayReference(double [] value){
		NumberArrayReference refx;

		refx = new NumberArrayReference();
		refx.numberArray = value;

		return refx;
	}


	public static NumberArrayReference CreateNumberArrayReferenceLengthValue(double length, double value){
		NumberArrayReference refx;
		double i;

		refx = new NumberArrayReference();
		refx.numberArray = new double [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.numberArray[(int)(i)] = value;
		}

		return refx;
	}


	public static void FreeNumberArrayReference(NumberArrayReference numberArrayReference){
		delete(numberArrayReference.numberArray);
		delete(numberArrayReference);
	}


	public static StringReference CreateStringReference(char [] value){
		StringReference refx;

		refx = new StringReference();
		refx.stringx = value;

		return refx;
	}


	public static StringReference CreateStringReferenceLengthValue(double length, char value){
		StringReference refx;
		double i;

		refx = new StringReference();
		refx.stringx = new char [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.stringx[(int)(i)] = value;
		}

		return refx;
	}


	public static void FreeStringReference(StringReference stringReference){
		delete(stringReference.stringx);
		delete(stringReference);
	}


	public static StringArrayReference CreateStringArrayReference(StringReference [] strings){
		StringArrayReference refx;

		refx = new StringArrayReference();
		refx.stringArray = strings;

		return refx;
	}


	public static StringArrayReference CreateStringArrayReferenceLengthValue(double length, char [] value){
		StringArrayReference refx;
		double i;

		refx = new StringArrayReference();
		refx.stringArray = new StringReference [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.stringArray[(int)(i)] = CreateStringReference(value);
		}

		return refx;
	}


	public static void FreeStringArrayReference(StringArrayReference stringArrayReference){
		double i;

		for(i = 0d; i < stringArrayReference.stringArray.Length; i = i + 1d){
			delete(stringArrayReference.stringArray[(int)(i)]);
		}
		delete(stringArrayReference.stringArray);
		delete(stringArrayReference);
	}


	public static void delete(System.Object objectx){
		// C# has garbage collection.
	}
}

}